//+------------------------------------------------------------------+
//|                                                      Monitor.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input int Timer=1;
input int Step=10;
input int Starts=10;
input int Ends=600;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class Monitor
  {
   string            Name;
   int               sizes,starts,ends,step,count_object;
   string            sName[];int snam;//   
   color             COLOR;
   long              chart_id;
public:
   void              Monitor();
   void             ~Monitor();
   void              init_Monitor(string name,int set_count=0);
   void              SetStep(int step_){step=step_;};
   void              SetStarts(int starts_){starts=starts_;};
   void              SetEnds(int ends_){ends=ends_;};
   int               GetSizes(){return(sizes);};
   void              CreateLabel(int x,int y,color COLOR);
   void              CreateLabel(int n,int x,int y,color COLOR);
   void              CreateLabel_(int n,int x,int y);
   string            GetName(int x,int y);
   string            GetName(int x);
private:
   void              initCreateLabel(int x,int y);
   void              initCreateLabel(int x);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::Monitor()
  {
   starts=Starts;//   
   ends=Ends;//   ()
   step=Step;// ,   (  .)   
   int Res=((ends-starts)/step)+1;//     
   ArrayResize(sName,Res*Res);//   
   chart_id=ChartID();
   snam=0;//    .
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::~Monitor()
  {
   for(int i=0;i<snam;i++)
      ObjectDelete(chart_id,sName[i]);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::init_Monitor(string name,int set_count=0)
  {
   bool fon=false; if(set_count==0)fon=true;
   Name=name;
   count_object=set_count;
   sizes=(ends-starts)/step;
   if(fon)
     {
      for(int k=0;k<=sizes;k++)
        {
         for(int n=0;n<=sizes;n++)
           {
            initCreateLabel(k,n);
           }
        }
     }
   else
     {
      for(int i=0;i<count_object;i++)
         initCreateLabel(i);
     }
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string Monitor::GetName(int x,int y)
  {
   string sk=(string)x,sn=(string)y;
   if(y<10)sn="00"+sn;
   else{if(y<100)sn="0"+sn;}
   if(x<10)sk="00"+sk;
   else{if(x<100)sk="0"+sk;}
   string name=Name+"_"+sk+"_"+sn;
   return(name);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string Monitor::GetName(int x)
  {
   string sk=(string)x;
   if(x<10)sk="00"+sk;
   else{if(x<100)sk="0"+sk;}
   string name=Name+"_"+sk+"__";
   return(name);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::CreateLabel(int x,int y,color COLOR)
  {
   string name=GetName(x,y);
   if(ObjectFind(chart_id,name)>=0)
     {
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,step*9);
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,COLOR);                   //  
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x*step+starts);       //  X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,(y+1)*step+2*starts); //  Y  
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::CreateLabel(int n,int x,int y,color COLOR)
  {
   string name=GetName(n);
   if(ObjectFind(chart_id,name)>=0)
     {
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,step*9);
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,COLOR);                   //  
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x*step+starts);       //  X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,(y+1)*step+2*starts); //  Y 
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::CreateLabel_(int n,int x,int y)
  {
   string name=GetName(n);
   if(ObjectFind(chart_id,name)>=0)
     {
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x*step+starts);       //  X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,(y+1)*step+2*starts); //  Y 
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::initCreateLabel(int x,int y)
  {
   string name=GetName(x,y);
   if(ObjectFind(chart_id,name)<0)
     {
      ObjectCreate(0,name,OBJ_LABEL,0,0,0,0,0);//  .
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_LOWER);//     
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);//       

      ObjectSetString(chart_id,name,OBJPROP_TEXT,".");
      ObjectSetString(chart_id,name,OBJPROP_FONT,"Times New Roman");
      sName[snam]=name; snam++;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Monitor::initCreateLabel(int x)
  {
   string name=GetName(x);
   if(ObjectFind(chart_id,name)<0)
     {
      ObjectCreate(0,name,OBJ_LABEL,0,0,0,0,0);//  .
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_LOWER);//     
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);//       

      ObjectSetString(chart_id,name,OBJPROP_TEXT,".");
      ObjectSetString(chart_id,name,OBJPROP_FONT,"Times New Roman");
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,0);
      sName[snam]=name; snam++;
     }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
Monitor fon;
Monitor pix;
int Sizes1,X,Y,i;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {

   fon.init_Monitor("fon");
   pix.init_Monitor("pix",4);
   fon.SetStep(Step);
   pix.SetStep(Step*2);
//---
   color COLOR;
   int Sizes=(Ends-Starts)/Step;
   for(int k=0;k<=Sizes;k++)
     {
      for(int n=0;n<=Sizes;n++)
        {
         if(((int)(k)%2==0 && (int)(n)%2==0) || ((int)(k)%2==1 && (int)(n)%2==1))
            COLOR=C'0,0,255';
         else COLOR=C'127,0,0';
         fon.CreateLabel(k,n,COLOR);
        }
     }
   
   Sizes1=(Ends-Starts)/(Step*2);
   X=Sizes1/2;Y=Sizes1/2;
   pix.CreateLabel(0,X,Y,Aqua);

   pix.CreateLabel(1,X  ,Y/2,White);
   pix.CreateLabel(2,X/2,Y/2,Yellow);
   pix.CreateLabel(3,X/2,  Y,Red);
   ChartRedraw(); 
   i=0;   
   do
     {
      Sleep(Timer*1000);
      _OnTimer(i);
     }
   while(!IsStopped());
  
  }
//+------------------------------------------------------------------+
void _OnTimer(int &i)
  {
   switch(i)
     {
      case 0:
         pix.CreateLabel_(1,3*X/2,  Y/2);
         pix.CreateLabel_(2,    X,  Y/2);
         pix.CreateLabel_(3,  X/2,  Y/2);
         i++;break;
      case 1:
         pix.CreateLabel_(1,3*X/2,    Y);
         pix.CreateLabel_(2,3*X/2,  Y/2);
         pix.CreateLabel_(3,    X,  Y/2);
         i++;break;
      case 2:
         pix.CreateLabel_(1,3*X/2,3*Y/2);
         pix.CreateLabel_(2,3*X/2,    Y);
         pix.CreateLabel_(3,3*X/2,  Y/2);
         i++;break;
      case 3:
         pix.CreateLabel_(1,    X,3*Y/2);
         pix.CreateLabel_(2,3*X/2,3*Y/2);
         pix.CreateLabel_(3,3*X/2,    Y);
         i++;break;
      case 4:
         pix.CreateLabel_(1,  X/2,3*Y/2);
         pix.CreateLabel_(2,    X,3*Y/2);
         pix.CreateLabel_(3,3*X/2,3*Y/2);
         i++;break;
      case 5:
         pix.CreateLabel_(1,  X/2,    Y);
         pix.CreateLabel_(2,  X/2,3*Y/2);
         pix.CreateLabel_(3,    X,3*Y/2);
         i++;break;
      case 6:
         pix.CreateLabel_(1,  X/2,  Y/2);
         pix.CreateLabel_(2,  X/2,    Y);
         pix.CreateLabel_(3,  X/2,3*Y/2);
         i++;break;
      default:
         pix.CreateLabel_(1,    X,  Y/2);
         pix.CreateLabel_(2,  X/2,  Y/2);
         pix.CreateLabel_(3,  X/2,    Y);
         i=0;break;
     }
   ChartRedraw();  
  };
//+------------------------------------------------------------------+
/*
[  X/2,  Y/2],[    X,  Y/2],[3*X/2,  Y/2];
[  X/2,    Y],[    X,    Y],[3*X/2,    Y];
[  X/2,3*Y/2],[    X,3*Y/2],[3*X/2,3*Y/2];
*/
//+------------------------------------------------------------------+
